<template>
    <div class="row">
        <div class="items-center q-pa-sm col-12">
            <div v-html="text"></div>
            <span class="time-text helvetica-neue-medium font-10 q-pr-xs">
                {{ time }}
            </span>
            <q-btn
                dense
                text
                flat
                v-if="statusIcon.name"
                @click="resendErrorMessage(statusIcon.name, message.id)"
            >
                <q-icon
                    :name="statusIcon.name"
                    :color="statusIcon.color"
                    size="15px"
                />
            </q-btn>
        </div>
    </div>
</template>

<style lang="scss" scoped>
.time-text {
    color: white;
}
.icon-container {
    width: 10px;
    height: 10px;
}
</style>

<script lang="ts">
import { defineComponent } from 'vue';
import MessageController from 'src/controller/MessageController';
import { Message } from 'src/services/models/Message';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'BubbleText',
    props: {
        message: {
            type: Object as () => Message,
            required: true
        },
        loading: {
            type: Boolean
        }
    },
    setup(props) {
        const store = useStore();

        const { isSender, text, time, statusIcon } = MessageController(
            props.message
        );

        const resendErrorMessage = (statusName: any, id: string) => {
            if (statusName == 'error') {
                store.dispatch('message/resendErrorMessage', id);
            }
        };

        return {
            isSender,
            text,
            time,
            statusIcon,
            resendErrorMessage
        };
    }
});
</script>
